         Installing LANCELOT on Sun workstations under SOLARIS
         -----------------------------------------------------

1. Installing LANCELOT.
   --------------------

We assume that all the files in the LANCELOT distribution package have
been placed   in a single   directory where you wish to   install  the
LANCELOT programs.  You should at least have:

    ALLIN.SIF      HS65.SIF    README.sol   SAMPLE.SPC  SAMPLE.SIF
    SPEC.SPC
    asmbl.f        assl.f      auglg.f      dumbr.f     bndsl.f
    cauch.f        cg.f        compil.sol   datal.f     decode.f
    drche.f        drchg.f     dumhsl.f     elgrd.f     frntl.f
    gps.f          gtpgr.f     hsprd.f      initw.f     inlanc.f
    instll.sol     inxac.f     lan.sol      lance.f     linpac.f
    local.f        makefn.f    makegr.f     makeop.sol  makesd.sol
    mdchl.f        misc.f      others.f     precn.f     printp.f
    rest.f         runlan.f    sbmin.f      scaln.f     sdlan.sol
    sort.f         runsd.f     speci.f      todble.sol  tosngl.sol
    tobig.f        tomed.f     totoy.f      utils.f     unfold.sol
    manual.err

These files fall into five categories:
    .f   files contain Fortran source code,
    .SIF files contain Standard Input Format files,
    .SPC files contain algorithmic specifications for the optimizers,
    .sol files contain machine dependent procedures and commands,
    .err files contain errata to the documentation.
There might be additional files for installation on other systems.

The installation  process requires  space  for  temporary  files.   By
default, these files  are  written in (and subsequently  removed from)
the directory /tmp.  If  you wish to write  these files elsewhere, you
must edit the  file "instll.sol" and change  the shell variable TMP to
point at an  appropriate  directory.  We recommend  using the  default
directory /tmp whenever  possible.

Note: The  current directory (TMP=.)  must not be  used  for temporary
      files.

LANCELOT also requires space for temporary  files while it is running.
By default, these files are written in (and subsequently removed from)
the directory  /tmp.  If you wish to  write these files elsewhere, you
must edit the files

   sdlan.sol
   lan.sol

and  change  the  shell  variable TMP  to point  at   an   appropriate
directory.

The installation process  uses  the Fortran  compiler/loader,  f77 and
some machine dependent constants and functions.  These as  well as the
compiler  flags have   been set  to default  values appropriate  for a
Sun Sparc 1 workstation.

Note: if, after installing LANCELOT, you  wish to  change the compiler
      flags and/or machine dependent constants and functions for  your
      machine/compiler, please  refer to  the  chapter  "How  LANCELOT
      works" in the Manual.

The LANCELOT procedures also  use some  basic UNIX  commands and the C
shell.    The  commands  are  cp  (copy  a  file),   mkdir  (create  a
subdirectory), chmod (change the  protection of a file),  mv (rename a
file),  rm  (remove  a  file),  cat  (lists  a  file),  make  (program
management  utility)  and  csh (C-shell).   It  is assumed that  these
commands  can be  found in the /usr/bin directory.  If this is not the
case, the machine dependent files should be edited and the  definition
of these commands updated according to the local installation.

The first thing you must do is to "unwrap" the package  and create the
suitable directory   structure.    This  is  achieved by   issuing the
commands

   mv unfold.sol unwrap
   chmod a+x unwrap
   unwrap

Note: the name "unwrap" is ESSENTIAL.

You now have the  choice between single  and double precision versions
(or  both).   You  also   have to choose    a  size   for the  package
executables.  Three  sizes are available with   preset options: small,
medium and large. Which size is  appropriate on your system depends on
the  memory  available to the  user.    If in doubt or  for customized
sizing,  we recommend that you install   the small size initially, and
then consult the Manual.

To install the single precision version of LANCELOT, simply type

   instll single small
or
   instll single medium
or
   instll single large

depending on which preassigned size you choose.

To install the double precision version of LANCELOT, simply type

   instll double small
or
   instll double medium
or
   instll double large

depending on which preassigned size you choose.

One such installation using the large size takes about 3  minutes on a
Sun Sparc ??.

2. Preparing LANCELOT.
   ------------------

The  environment variable LANDIR  is  used  by the LANCELOT  commands.
This variable should be set to point to  the LANCELOT directory, which
is

   ./lancelot

where . is the current directory.  We suggest this  variable is set in
the user's .cshrc file by inserting in this file the command

   setenv LANDIR (full path name of the LANCELOT directory)

The user may need to be able to run the scripts

   sdlan
   lan

from  any directory.  This can  be achieved in  a  number of ways. The
simplest is to include the lines

   alias sdlan $LANDIR/sdlan
   alias lan $LANDIR/lan

anywhere after the line setting the LANDIR environment variable in the
user's .cshrc file.

The new version of the file .cshrc will subsequently  be active in all
new shells and can be made active in the  current shell by issuing the
command

   source (absolute path name of the user's .cshrc file)


3. Running LANCELOT.
   ----------------

To run LANCELOT on a new optimization problem, move into the directory
in which the SIF file for the problem, (sif file name).SIF, resides.
Now issue the command

   sdlan -s (sif file name)

to run the single precision package or

   sdlan (sif file name)

to run  the double precision version.  LANCELOT  will decode  the SIF
file, print a short summary of problem characteristics and  attempt to
solve the associated problem.

For instance, move into the directory ./sampleproblems and issue the
command

   sdlan ALLIN

LANCELOT  will then  solve  the associated simple   problem  using the
double precision version of the package.

This run  uses a default   LANCELOT specification file.   This file is
copied from the lancelot directory $LANDIR  to the file  "SPEC.SPC" in
the current directory.  The user may change  the specification options
by editing this file as explained in the Manual.

Once the problem has been decoded,  it  may be resolved with different
specification options by using the "lan" script.

4. LANCELOT Manual
   ---------------

The complete documentation on LANCELOT is available in the book

   A.R. Conn, Nick Gould and Ph.L. Toint,
   "LANCELOT: a Fortran package for large-scale nonlinear optimization",
   Springer Series in Computational Mathematics, vol. 17,
   Springer Verlag (Heidelberg, New York), 
   ISBN 3-540-55470-X, 1992.

The user is, of course, urged to read this Manual.  An up-to-date list of
errata is given in the file "manual.err".

Good luck!

A. Conn
N. Gould
Ph. Toint
May 30, 1991.
