#
#  Produces object files for the LANCELOT optimizers
#
#  version for Sun workstations under SOLARIS

#  Philippe Toint, November 25th, 1991, for CGT Productions.

#
#  Basic system commands
#

CP = /bin/cp
RM = /bin/rm -f

#
# Set directories for single and double precision object files
#

ODS = ../../objects/single
ODD = ../../objects/double

#
#  Set directory for temporary object files
#  (do NOT use TMP = . which would cause file overwriting)
#

TMP = /tmp

#
#  Default precision
#

PRC = todble
OD  = $(ODD)

#
#  Default sizing program
#

SIZE = totoy

#
#  Compiler flags
#

FORTRAN = f77
FFLAGS  = -O -c

#
#  Filtering rule
#

.SUFFIXES: .o .f
.f.o:
	../$(PRC) < $< | ../$(SIZE) > $(TMP)/$<
	$(FORTRAN) $(FFLAGS) -o $(OD)/$*.o $(TMP)/$<
	$(RM) $(TMP)/$<

#
#  List of object files to create
#

OB = asmbl.o   auglg.o   dumbr.o  cauch.o   cg.o     drche.o  lance.o  \
     drchg.o   elgrd.o   frntl.o  gtpgr.o   local.o  hsprd.o  inxac.o  \
     sort.o    linpac.o  assl.o   misc.o    mdchl.o  precn.o  others.o \
     runlan.o  sbmin.o   datal.o  dumhsl.o  speci.o  scaln.o  initw.o  \
     bndsl.o

#
#  Info
#

info:
	@ echo "Possible choices are:"
	@ echo " - lancelot_s: the single precision LANCELOT optimizers,"
	@ echo " - lancelot_d: the double precision LANCELOT optimizers,"
	@ echo " - info: this information."

#
#  The compilations
#

lancelot_s:
	$(CP) ../local.f local.f
	$(MAKE) $(OB) PRC=tosngl SIZE=$(SIZE) TMP=$(TMP) OD=$(ODS)
	$(RM) local.f

lancelot_d:
	$(CP) ../local.f local.f
	$(MAKE) $(OB) PRC=todble SIZE=$(SIZE) TMP=$(TMP) OD=$(ODD)
	$(RM) local.f


