#
#  Compiling the SIF file decoder.
#
#  version for Sun workstations under SOLARIS

#
#  Ph. Toint, November 21rst, 1991, for CGT Productions.
#

#
#  Basic system commands
#

RM=/bin/rm -f
CP=/bin/cp
MV=/bin/mv

#
#  Temporary directory for compilation
#  (do NOT use TMP = . which would cause file overwriting)
#

TMP=/tmp

#
#  Default sizing program
#

SIZE=totoy

#
#  Default precision
#

PRC=todble

#
#  Compiler flags (machine dependent)
#

FORTRAN = f77
FFLAGS  = -O -c
FFLAGSLD=

#
#  Filtering rule
#

.SUFFIXES: .o .f
.f.o:
	../$(PRC) < $< | ../$(SIZE) > $(TMP)/$<
	$(FORTRAN) $(FFLAGS) -o $(TMP)/$*.o $(TMP)/$<
	$(RM) $(TMP)/$<

#
#  list of object files created
#

OBJ=gps.o   decode.o  rest.o  inlanc.o  utils.o  makefn.o  makegr.o  printp.o \
    local.o runsd.o

#
#  Info
#

info:
	@ echo "Possible choices are:"
	@ echo " - sifdec_s: the single precision problem decoder,"
	@ echo " - sifdec_d: the double precision problem decoder,"
	@ echo " - info: this information."

#
#  The compilations
#

sifdec_s:
	$(CP) ../local.f local.f
	$(MAKE) $(OBJ) PRC=tosngl SIZE=$(SIZE) TMP=$(TMP)
	$(RM) local.f
	cd $(TMP); $(FORTRAN) $(FFLAGSLD) -o sifdec_s $(OBJ); $(RM) $(OBJ)
	$(MV) $(TMP)/sifdec_s ../../sifdec_s

sifdec_d:
	$(CP) ../local.f local.f
	$(MAKE) $(OBJ) PRC=todble SIZE=$(SIZE) TMP=$(TMP)
	$(RM) local.f
	cd $(TMP); $(FORTRAN) $(FFLAGSLD) -o sifdec_d $(OBJ); $(RM) $(OBJ)
	$(MV) $(TMP)/sifdec_d ../../sifdec_d

